c
c     Wr2TSC    begins                      ---------------------------|
c     -                                                                |
c     -                                                                |
      SUBROUTINE PJrfIgrl
c     Computes the integrals of Prf, Pql, Jrf, as function of psi
#include "Implic.inc"
#include "params.inc"
#include "power.inc"
#include "PIetc.inc"
#include "Jrf.inc"
#include "PlPr.inc"
#include "ProfBody.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
#include "TSCgrap.inc"
#include "tscunits.inc"
c
      CHARACTER*46 TSCstring
      CHARACTER*47 Mystring
      INTEGER ips
      REAL    nRdotNorm(NPSIDIM)
      REAL    jRdotNorm(NPSIDIM)
c
c     Integrate Pray and Pql in LSC flux surfaces
      PrIntgrl(1) = PRayTot(1)
      PqIntgrl(1) = PqlTot (1)
      do ips = 2, Npsi
         PrIntgrl(ips) = PrIntgrl(ips-1) + PRayTot(ips)
         PqIntgrl(ips) = PqIntgrl(ips-1) + PqlTot(ips)
      enddo
c
c     Integrate Jrf and Jrf-plus in LSC flux surfaces
c     Divide by 2 pi R to make an area element !
      IrIntgrl(1) = js (1) * dVol(1) / (TWOPI * xmag )
      IpIntgrl(1) = jsp(1) * dVol(1) / (TWOPI * xmag )
      do ips = 2, npsi
         IrIntgrl(ips) = IrIntgrl(ips-1) + js(ips)*dVol(ips) /
     ^                                    (TWOPI * xmag )
         IpIntgrl(ips) = IpIntgrl(ips-1) +jsp(ips)*dVol(ips) /
     ^                                    (TWOPI * xmag )
      enddo

      do ips=1,Npsi
         if (PrIntgrl(ips) .le. 0.05 * PrIntgrl(Npsi) .or.
     ^       PrIntgrl(ips) .ge. 0.95 * PrIntgrl(Npsi)     ) then
             nRunDot(ips) = 0.00
             jRunDot(ips) = 0.00
         endif
         nRdotNorm(ips) = nRunDot(ips)/(NeAry(ips) + 1.e10)
         jRdotNorm(ips) = jRunDot(ips)/(   js(ips) + 1.e01)
      enddo
      
      if (PlFlg(RFDPSPL) .ge. TRUE) then
        call EZinit
        call GNinit(nTSCgraf)
c
        call Plt6Norm (PsiAry, PRayTot,  Npsi,   'Pray' , 1,' ')
c       call Plt6Norm (PsiAry, nRunDot,  Npsi ,'nRdot ' , 2,' ')
        call Plt6Norm (PsiAry, PqlTot,   Npsi,   'Pql ' , 2,' ')
c replc call Plt6Norm (PsiAry, PqlTot,   Npsi,   'Pql ' , 2,' ')
        call Plt6Norm (PsiAry, js,       Npsi ,  'Jql ' , 3,' ')
        call Plt6Norm (MidAry, PrIntgrl, Npsi, 'I Pray' , 4,' ')
c replc call Plt6Norm (PsiAry, jRunDot,  Npsi, 'jRdot ' , 5,' ')
c replc call Plt6Norm (MidAry, PqIntgrl, Npsi, 'I Pql ' , 5,' ')
        call Plt6Norm (MidAry, PqIntgrl, Npsi, 'I Pql ' , 5,' ')
c       call Plt6Norm (PsiAry, vRunIdx,  Npsi, 'ivRun ' , 5,' ')
        call Plt6Norm (MidAry, IrIntgrl, Npsi, 'I Jql ' , 6,' ')
c
c       TSCstring = ' Prf nRd Jrf w integral; LSC  '/ /EquTitle(81:96)
        TSCstring = ' Prf Pql Jrf w integral; LSC  '/ /EquTitle(81:96)
        Mystring = TSCstring / / '$'
        call MkGrfLst(TSCstring)
        call EZwrit(50,700,Mystring,0,0)
        call EZfini(0,0)
        call GNfini

      endif

      return
      END
c
      SUBROUTINE Wr2TSC(PelFnd, JrfFnd, PqlFnd)
#include "Implic.inc"
#include "tscunits.inc"
#include "params.inc"
#include "PIetc.inc"
#include "PlPr.inc"
#include "Jrf.inc"
#include "power.inc"
#include "ProfBody.inc"
#include "TSCgrap.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
#include "WkAry.inc"
      CHARACTER*46 TSCstring
      CHARACTER*47 Mystring
      CHARACTER*6  chrst6
      INTEGER  l, NumZeros, iion
      INTEGER iDBG, iamu, ichg
c     EQUIVALENCE (npsit, NpsiJ)
      REAL    PelFnd, JrfFnd, PqlFnd, PioFnd
      REAL    xlookup, yreturn, ydumy(NPSIDIM)
      REAL    powtsc (PPSI ), curtsc (PPSI), curtscp (PPSI), 
     ^        powDql (PPSI ), dlnJdlnE(PPSI)
      REAL    powtscSm(PPSI)
      REAL                    dJdETRAN(PPSI)
      REAL    powtscI(PPSI ), curtscI(PPSI), curtscIp(PPSI), 
     ^        powDqlI(PPSI )
c
      REAL       PowFac     ,        CurFac   
      DATA       PowFac     ,        CurFac  /
     ^     CONST(1.0,-6)    ,  CONST(1.0,-4) /
c             m^3 per cm^3  , m^2 per cm^2 
c
      DATA    iDBG /0/
c
c     We write to TSC quantities of heating rate and current
c     driven based on the TSC \psi-grid.  These were accumulated on a 
c     \psi-grid that is different.  It was made different so
c     that the heating rate and current driven stuff could have grids 
c     concentrating on where the action was.
c     powtscSm  power to TSC Smoothed proportional to anecc*Jrf
c     
c     We do the interpolation with linr1d (LINeaR 1D), which
c     does not introduce swings in the interpolant, such as where
c     the function becomes non zero after being flat at zero.
c
ccc   First integrate the power and current driven.  The points at which
ccc   integrals are known are between the points at which \psi is given.
ccc
ccc      int1      int2      int3      int4       int5  int6
ccc        |         |         |         |          |    |
ccc psi1      psi2      psi3      psi4       psi5      psi6
ccc   .         .         .         .          .         .
c
      call PJrfIgrl

      do 10 l = 1, NpsiJ - 1
         xlookup =  MidVec(l)
c
c     interpolate for power integral
         call linr1d(Npsi, MidAry, PrIntgrl, 
     ^               xlookup, yreturn)
         powtscI(l) =  abs( yreturn )
c        powtscI is the power in watts inside the l flux surface boundary
c
c     interpolate for current integral
         call linr1d(Npsi, MidAry, IrIntgrl, 
     ^               xlookup, yreturn)
         curtscI (l)=  yreturn
c        curtscI is the current in amps inside the l flux surface boundary

c     interpolate for current integral at enhanced E [ E plus dE]
         call linr1d(Npsi, MidAry, IpIntgrl, 
     ^               xlookup, yreturn)
         curtscIp(l)=  yreturn
c        curtscIp is the current in amps inside the l flux surface boundary
c
c     interpolate for the ql power deposited
         call linr1d(Npsi, MidAry, PqIntgrl, 
     ^               xlookup, yreturn)
         powDqlI(l) =  yreturn 
 10   continue

         powtscI (NpsiJ) = PrIntgrl(Npsi)
         curtscI (NpsiJ) = IrIntgrl(Npsi)
         curtscIp(NpsiJ) = IpIntgrl(Npsi)
         powDqlI (NpsiJ) = PqIntgrl(Npsi)

         powtscI (NpsiJ-1) = PrIntgrl(Npsi)
         curtscI (NpsiJ-1) = IrIntgrl(Npsi)
         curtscIp(NpsiJ-1) = IpIntgrl(Npsi)
         powDqlI (NpsiJ-1) = PqIntgrl(Npsi)

c
c     divide by volume for power, area for current.  
c     Note backward volume convention
           l = 1
           powtsc(l) = PowFac * (powtscI (l)             )/
     ^                           dVlVec(l)
           powDql(l) = PowFac * (powDqlI (l)             )/
     ^                           dVlVec(l)
           curtsc (l)= CurFac * (curtscI (l)             )/
     ^                         ( dVlVec(l) / (TWOPI * xmag) )
           curtscp(l)= CurFac * (curtscIp(l)             )/
     ^                         ( dVlVec(l) / (TWOPI * xmag) )

         do 20 l = 2, NpsiJ 

           powtsc(l) = PowFac * (powtscI (l)-powtscI(l-1))/
     ^                           dVlVec(l)
           powDql(l) = PowFac * (powDqlI (l)-powDqlI(l-1))/
     ^                           dVlVec(l)
           curtsc (l)= CurFac * (curtscI (l)-curtscI (l-1))/
     ^                         ( dVlVec(l) / (TWOPI * xmag) )
           curtscp(l)= CurFac * (curtscIp(l)-curtscIp(l-1))/
     ^                         ( dVlVec(l) / (TWOPI * xmag) )
c          I have to mult by 2 pi R to make an area!

 20      continue

c
         do 30 l = 1, NpsiJ
           if(curtsc (l) .eq. 0.00 .or. 
     ^          dEdcAmnt .eq. 0.00 .or. 
     ^         EdcVec(l) .eq. 0.00      ) then
             dlnJdlnE(l) = 0.00
           else
             dlnJdlnE(l) = (curtscp(l) - curtsc (l))/curtsc (l)  *
     ^                                   EdcVec (l) / dEdcAmnt   
           endif
c! TRANSP REQUEST:                                                           !
             dJdETRAN(l) = (curtscp(l) - curtsc (l))/ dEdcAmnt   

 30      continue
c
c                                       Make sure we do not append information
      rewind (unit = nTSCread)
c
c                          powtsc is in watts/cc
c                          curtsc is in amps/cm**2
c                          powtscI is in watts
c                          curtscI is in amps

      PelFnd = powtscI(NpsiJ)
      JrfFnd = curtscI(NpsiJ)
      PqlFnd = powDqlI(NpsiJ)

      write(nTSCread,1011) (powtsc  (l),l=1,npsiJ-1)
      write(nTSCread,1012) (curtsc (l),l=1,npsiJ-1)
      write(nTSCread,1013) (dlnJdlnE(l),l=1,npsiJ-1)
      write(nTSCread,1014) (dJdETRAN(l),l=1,npsiJ-1)
c
c     compute the interpolated power for each ion, and then
c     write it out.  The outer loop on ions uses the array powtsc
c     over and over.
      PioFnd = 0.
      do iion = 1,nspc
         iamu = int (amass(iion)/1.6e-24 + 0.5)
         ichg = int (achrg(iion)         + 0.5)
         write(chrst6,'(''Pamu'',i2)')iamu
         if      (iamu .eq. 1 .and. ichg .eq. 1) then
            chrst6='Pprot'
         else if (iamu .eq. 2 .and. ichg .eq. 1) then
            chrst6='Pdeut'
         else if (iamu .eq. 3 .and. ichg .eq. 1) then
            chrst6='Ptrit'
         else if (iamu .eq. 3 .and. ichg .eq. 2) then
            chrst6='Phe-3'
         else if (iamu .eq. 4 .and. ichg .eq. 2) then
            chrst6='Phe-4'
         else if (iamu .eq. 12 .or. ichg .eq. 6) then
            chrst6='Pcarb'
         else if (iamu .eq. 16 .or. ichg .eq. 8) then
            chrst6='Poxy '
         endif
         do l = 1, NpsiJ - 1
            powtscI(l) =  0.00
         enddo
            powtscI (NpsiJ)   = 0.00
            powtscI (NpsiJ-1) = 0.00
               l = 1
               powtsc(l) = PowFac * (powtscI (l)             )/
     ^                              dVlVec(l)
            do l = 2, NpsiJ 
               powtsc(l) = PowFac * (powtscI (l)-powtscI(l-1))/
     ^                               dVlVec(l)
             enddo
             if (iion .eq. 1) then
         write(nTSCread,1015) (powtsc  (l),l=1,npsiJ-1)
             else if (iion .eq. 2) then
         write(nTSCread,1016) (powtsc  (l),l=1,npsiJ-1)
             else if (iion .eq. nspc) then
         write(nTSCread,1017) (powtsc  (l),l=1,npsiJ-1)
             else 
         write(nTSCread,1001) (powtsc  (l),l=1,npsiJ-1)
             endif
         PioFnd = PioFnd + powtscI(NpsiJ)

      enddo

      write(nTSCread,1003) npsiJ
      write(nTSCread,1001) (powDql (l),l=1,npsiJ-1)
      write(nTSCread,1004) PelFnd, PqlFnd, JrfFnd
      write(nTSCread,'(''EOF '')')
c
c                                       Make sure the reader does not hit EOF
      rewind (unit = nTSCread)
c
c                                       Try to trap an error where most of
c                                       the power and current values are zero.
c                                       This trap was installed because of
c                                       apparent intermittent returns of 
c                                       zero current drive and heating.
c                                       This trap could be removed if a bug
c                                       is found.
      NumZeros = 0
      do 50 l=1,NpsiJ
        if (powtsc(l) .eq. 0.000e+00 .and. curtsc(l) .eq. 0.000e+00)
     ^                   NumZeros = NumZeros + 1
 50   continue
      if (NumZeros .gt. ((npsiJ-1) - (npsiJ/6)) ) 
     ^                   call LSCstop(' no rf current or heating')
c                                       End of zeros trap
c
c     .                                 Call FastFrac every time, but write it
c     .                                 out only if the proper flag is set.
c     .                                 New FastFrac logic at request of TRANSP
      call FastFrac(Npsi)

 1001 format(5e16.6)

 1011 format(5e16.6, t82,'Electron power')
 1012 format(5e16.6, t82,'Electron current')
 1013 format(5e16.6, t82,'d lnJ/d lnE')
 1014 format(5e16.6, t82,'dJ/dE')
 1015 format(5e16.6, t82,'1st  ion power')
 1016 format(5e16.6, t82,'2nd  ion power')
 1017 format(5e16.6, t82,'last ion power')

 1003 format('EOF',/,
     ^       ' The above are powtsc in watts/cc ',/,
     ^       ' and curtsc in amps/cm^2,',/,
     ^       ' and d lnJ / d lnE which is dimensionless,',/,
     ^       ' and dJ / dE in amp/cm^2 / volt/m ,',/,
     ^       ' with npsiJ = ',i5,/,
     ^       ' The following is PowDql, which is similar to powtsc.')
 1004 format('EOF',/,
     ^' Total Power, Pel, Pql; and Total Current, Irf',/,
     ^       5e16.6 )


      do 60 l=1,Npsi,2
        ydumy(l) = vnormPos(l)
 60   continue
      do 61 l=2,Npsi,2
        ydumy(l) = vnormNeg(l)
 61   continue
      do 62 l=(Npsi*14)/15, Npsi
        ydumy(l)=0.
 62   continue
 63   continue

      if (iDBG .eq. TRUE) then
        call EZinit
        call Plt6Norm (xsv,    powtsc,   NpsiJ,  'Ptsc' , 1,' ')
        call Plt6Norm (MidVec, powtscI,  NpsiJ,'I Ptsc' , 2,' ')
        call Plt6Norm (MidAry, PrIntgrl, Npsi, 'I Plsc' , 3,' ')
        call Plt6Norm (xsv,    curtsc,   NpsiJ,  'Jtsc' , 4,' ')
        call Plt6Norm (MidVec, curtscI,  NpsiJ,'I Jtsc' , 5,' ')
        call Plt6Norm (MidAry, Irintgrl, Npsi, 'I Jlsc' , 6,' ')
        TSCstring = ' Prf Jrf TSC w integral; LSC '/ /EquTitle(81:96)
        Mystring = TSCstring / / '$'
        call MkGrfLst(TSCstring)
        call EZwrit(50,700,Mystring,0,0)
        call EZfini(0,0)
      endif

      if(PlFlg(JRFPL).ge. TRUE      ) then
        call EZinit
        TSCstring = ' Ne Te Edc dJdE Itsc Run vs r'/ /EquTitle(81:96)
        Mystring = TSCstring / / '$'
        call EZwrit(50,700,Mystring,0,0)
        call GNwrit(50,700,Mystring,0,0)
c
        call Plt6Norm (PsiAry, NeAry , Npsi,  'Ne '  ,  1,'.')
        call Plt6Norm (PsiAry, ydumy , Npsi,  'Run'  ,  2,'.')
        call Plt6Norm (MidVec, curtscI, NpsiJ,'Itsc' ,  3,' ')
        call Plt6Norm (PsiAry, TeAry , Npsi,  'Te '  ,  4,',')
        call Plt6Norm (PsiAry, EdcAry, Npsi,  'Edc ' ,  5,' ')
        call Plt6Norm (xsv,  dlnJdlnE, NpsiJ, 'LdJdE',  6,' ')
c
        call MkGrfLst(TSCstring)
        call EZfini(0,0)
      endif

      if(PlFlg(PITPRFPL) .ge. TRUE ) then
        call PitchPrf

      endif
      return
      END
c     ------------------------------------------------------------------
      SUBROUTINE Plt6Norm (x, y, NumPts, chrts6, iplace, GrTyp)
#include "Implic.inc"
      CHARACTER*1 GrTyp
      INTEGER iplace, NumPts, MAXPts, n
      PARAMETER (MAXPts = 451)
      REAL     x(NumPts),  y(NumPts)
      REAL    xg(MAXPts), yg(MAXPts)
      CHARACTER *(*) chrts6
      INTEGER  PltsOnPg, i, iCross0, iydiv(2), iyinv(2)
      PARAMETER (PltsOnPg =6)
      INTEGER nxlo(PltsOnPg) , nxhi(PltsOnPg),
     ^        nylo(PltsOnPg) , nyhi(PltsOnPg), nywri(PltsOnPg)
      INTEGER ixlo(PltsOnPg) , ixhi(PltsOnPg),
     ^        iylo(PltsOnPg) , iyhi(PltsOnPg), iywri(PltsOnPg)


      REAL    xmin, xmax, ymin(2), ymax(2)
      REAL    ymnVal, ymxVal
      CHARACTER*24 MyString
      CHARACTER*24 NDString
      DATA       xmin  ,       xmax   /
     ^     CONST(0.0,0), CONST(1.0,0) /
      DATA      ymin(1),      ymin(2) ,      ymax(1),      ymax(2) /
     ^     CONST(0.0,0), CONST(-2.0,0), CONST(1.5,0), CONST(2.0,0) /
      DATA     iydiv(1), iydiv(2), iyinv(1), iyinv(2) /
     ^            3    ,   2     ,   1     ,   2      /
      DATA    (nxlo(i) , i=1,PltsOnPg) 
     ^       / 50,      400,      750,       50,      400,      750  /
      DATA    (nxhi(i), i=1,PltsOnPg) 
     ^    /   300,      650,     1000,      300,      650,     1000  /
      DATA    (nylo(i) , i=1,PltsOnPg) 
     ^      / 400,      400,      400,        50,      50,       50  /
      DATA   (nyhi(i) , i=1,PltsOnPg) 
     ^      / 650,      650,      650,       300,     300,      300  /
      DATA   (nywri(i) , i=1,PltsOnPg) 
     ^      / 625,      625,      625,       275,     275,      275  /

      DATA    (ixlo(i) , i=1,PltsOnPg) 
     ^       /  0,      340,      680,        0,      340,      680  /
      DATA    (ixhi(i), i=1,PltsOnPg) 
     ^    /   340,      680,     1020,      340,      680,     1020  /
      DATA    (iylo(i) , i=1,PltsOnPg) 
     ^      / 380,      380,      380,        0,        0,        0  /
      DATA   (iyhi(i) , i=1,PltsOnPg) 
     ^      / 760,      760,      760,       380,     380,      380  /
      DATA   (iywri(i) , i=1,PltsOnPg) 
     ^      / 625,      625,      625,       275,     275,      275  /

c
c     -                                 Set x to root of normalized \psi
    
      n = NumPts
      if (n .gt. MAXPts) n = MAXPts
      do 10 i = 1, n
        xg(i) = ( x(i) - x(1) ) /
     ^     ( x(NumPts) - x(1) )
        xg(i) = sqrt ( xg(i) ) 
 10   continue
c
      i = iplace
      call EZnorm ( y, yg , ymnVal, ymxVal, n, iCross0 )
      write (MyString, '( a6, '' /'', 1pe8.1,''$'')') chrts6, ymxVal
      write (NDString, '( a6, '' /'', 1pe8.1,''$'')') chrts6, ymxVal
      call EZsets ( nxlo(i), nxhi(i), nylo(i), nyhi(i),
     ^                xmin, xmax, ymin(iCross0),ymax(iCross0), 1 )
      call EZaxes ( 1 , 10, iydiv(iCross0), iyinv(iCross0) )
      call EZwrit ( nxlo(i), nywri(i), MyString , 0, 0 )

      call GNsets ( ixlo(i), ixhi(i), iylo(i), iyhi(i),
     ^                xmin, xmax, ymin(iCross0),ymax(iCross0), 1 )
      call EZwrit ( nxlo(i), nywri(i), MyString , 0, 0 )
      call GNtitl (                    NDString        )

      if 
     ^ (GrTyp .eq. ' ' .or. GrTyp .eq. 'l' .or. GrTyp .eq. '-') then
        call EZcurv ( xg , yg , n )
        call GNcurv ( xg , yg , n )
      else if 
     ^ (GrTyp .eq. 'x' .or. GrTyp .eq. 'X' .or. GrTyp .eq. '*') then
        call EZcros ( xg , yg , n )
        call GNcros ( xg , yg , n )
      else if 
     ^ (GrTyp .eq. 'b' .or. GrTyp .eq. 'B' .or. GrTyp .eq. '|') then
        call EZbars ( xg , yg , n ,'y')
        call GNbars ( xg , yg , n ,'y')
      else if
     ^ (GrTyp .eq. 'p' .or. GrTyp .eq. 'P' .or. GrTyp .eq. '.') then
        call EZpnts ( xg , yg , n )
        call GNpnts ( xg , yg , n )
      else if
     ^ (GrTyp .eq. 's' .or. GrTyp .eq. 'S' .or. GrTyp .eq. ',') then
        call EZpnt2 ( xg , yg , n )
        call GNpnt2 ( xg , yg , n )
      else
        call EZcurv ( xg , yg , n )
        call GNcurv ( xg , yg , n )
      endif
c     
      return
      END
c
c     -----------------------------------------------------------------
c
      SUBROUTINE PitchPrf
#include "Implic.inc"
#include "params.inc"
#include "dielec.inc"
#include "RayBins.inc"
#include "RayWrk.inc"
#include "ProfBody.inc"
#include "TSCgrap.inc"
#include "power.inc"
      INTEGER i,ii,ix,ixi,iy,iyi,j, NUMPTS, NUMSMO
      PARAMETER (NUMPTS=200, NUMSMO=8)
      REAL    
     ^        r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael
      REAL    
     ^        x(NUMPTS),Pitch(NUMPTS),PitchDeg(NUMPTS),PowerDep(NUMPTS)
      REAL    
     ^        Bpol, Btot, Enh(NUMPTS)
      REAL    
     ^        Dens(NUMPTS), TempAry(NUMPTS)
      REAL    
     ^        PowerMax, PitchMin, PitchMax, DensMax,
     ^        temp1,    temp2,    temp3
      REAL    
     ^           ZERO  ,       ONE   ,       ONEPT5,       TEN    
      DATA       ZERO  ,       ONE   ,       ONEPT5,       TEN    /
     ^     CONST(0.0,0), CONST(1.0,0), CONST(1.5,0), CONST(10.0,0)/

      REAL       PT1,          TENm20,         PT98
      DATA       PT1   ,       TENm20  ,       PT98    /
     ^     CONST(0.1,0), CONST(1.0,-20), CONST(0.98,0) /
c
      do i=1,NUMPTS
        x(i) = RlcfsMin +
     ^        (RlcfsMax-RlcfsMin)/float(NUMPTS-1)*float(i-1)
        r = x(i)
        z = ZERO
        call plasma2d (r,z, psi,Br,Bz,RBphi,omc,Tee,pe2,pi2,aio,ael)
c     
        if (pe2 .le. ZERO ) then
           Enh(i) = ONE
           Bpol   = ZERO
        else
            call eps (r , z , ZERO, ZERO)
            Bpol = sqrt ( Br*Br + Bz*Bz )
            Btot = sqrt ( Bpol*Bpol + RBphi*RBphi/r /r  )
            Enh(i) = ( r /RlcfsMax ) * ( ONE
     ^                       -sqrt(abs(ONE-Epar))*
     ^                       Bpol/Btot/sqrt(abs(Eper))  ) 
     ^                      
            if(Enh(i) .le. PT1 ) Enh(i) = PT1
            Enh(i) = ONE / Enh(i)
        endif
c
        Pitch(i)    = Bz/RBphi*r
        PitchDeg(i) = atan(Pitch(i))* (180./3.1415926)
        ii = 0
        PowerDep(i) = ZERO
        Dens(i)     = pe2
        if (pe2 .gt. ZERO) then
          do j=2,Npsi
            if(PsiAry(j) .ge. psi .and. PsiAry(j-1) .lt. psi ) then
              PowerDep(i) = PowerDep(i) + PrayTot(j)
              ii = ii+1
            endif
          enddo
              PowerDep(i) = PowerDep(i)/(float(ii)+.001)
          continue
        endif

      enddo
c     .
      do 21 i=1,NUMPTS
        TempAry(i)=PowerDep(i)
 21   continue
c
      do 30 i=1,NUMPTS
        temp1 = ZERO
        do 25 j=-NUMSMO,NUMSMO,1
          ii = i+j
          if (ii .lt. 1     ) ii = 1
          if (ii .gt. NUMPTS) ii = NUMPTS
          temp1 = temp1+TempAry(ii)
 25     continue
        PowerDep(i) = temp1 / float(2*NUMSMO + 1)
 30   continue
        
      PowerMax = ZERO
      PitchMin = ZERO
      PitchMax = ZERO
      do 40 i=1,NUMPTS
        if (PitchMin .gt.    Pitch(i)) PitchMin = Pitch(i)
        if (PitchMax .lt.    Pitch(i)) PitchMax = Pitch(i)
        if (DensMax  .lt.    Dens(i) ) DensMax  = Dens(i)
        if (PowerMax .lt. PowerDep(i)) PowerMax = PowerDep(i)
 40   continue

      do 50 i=1,NUMPTS
        PowerDep(i)=PowerDep(i)/(PowerMax + TENm20 )*PT98
        Dens(i)    =Dens(i)    /(DensMax  + TENm20 )*PT98
 50   continue

      PitchMax =  max (PitchMax, abs(PitchMin))
      
      call EZrnd2 (RlcfsMax,temp2,i,ii)
      temp1 = temp2-RlcfsMin
      call EZrnd2 (temp1,temp1,ix,ixi)
      temp1=temp2-temp1
c      temp2 = 2.0
c      temp1 = 1.2
      ix =4
      ixi=1
      call EZinit
      call EZrndu(PitchMax,PitchMax, iy)
      iyi = 1
      PitchMin = - PitchMax
      call EZsets (100,450,475,700,temp1,temp2,PitchMin,PitchMax,1)
      call EZwrit (125, 725,'Bz/Bphi vs Rmaj$',0,0)

      call GNsets (  0,500,380,760,temp1,temp2,PitchMin,PitchMax,1)
      call GNtitl (         'Bz/Bphi vs Rmaj$'    )

      call EZcurv ( x  , Pitch, NUMPTS)
      call EZaxes (ix,ixi,iy,iyi)
      call GNcurv ( x  , Pitch, NUMPTS)
c
      PitchMax = 10.
      PitchMin =-10.
      iy=2
      iyi=2
      call EZsets (100,450,100,325,temp1,temp2,PitchMin,PitchMax,1)
      call EZwrit (125, 350,'Pitch in deg vs Rmaj$',0,0)
      call EZcurv ( x  , PitchDeg, NUMPTS)
      call EZaxes (ix,ixi,iy,iyi)

      call GNsets (  0,500,  0,380,temp1,temp2,PitchMin,PitchMax,1)
      call GNtitl (         'Pitch in deg vs Rmaj$'    )
      call GNcurv ( x  , PitchDeg, NUMPTS)
c
      call EZsets (600,950,100,325,temp1,temp2, ZERO   ,ONEPT5,1)
      call EZwrit (625,        350,'Ne_ Prf... vs Rmaj$',0,0)
      call EZaxes (ix,ixi,   3,1)
      call EZcurv ( x  , Dens    , NUMPTS )
      call EZpnts ( x  , PowerDep, NUMPTS )

      call GNsets (500,1000, 0,380,temp1,temp2, ZERO   ,ONEPT5,1)
      call GNtitl (                'Ne_ Prf... vs Rmaj$'    )
      call GNcurv ( x  , Dens    , NUMPTS )
      call GNpnts ( x  , PowerDep, NUMPTS )

      call EZsets (600,950,475,700,temp1,temp2, ZERO   ,TEN,1)
      call EZwrit (625,        725,'Npar enhance vs Rmaj$',0,0)
      call EZaxes (ix,ixi,   2,5)
      call EZpnts ( x  , Enh     , NUMPTS )

      call GNsets (500,1000,380,760,temp1,temp2, ZERO   ,TEN,1)
      call GNtitl (                'Npar enhance vs Rmaj$'    )
      call GNpnts ( x  , Enh     , NUMPTS )
c
c
      call MkGrfLst(' Pitch Pray Ne Npar gain vs R ')
      call EZfini(0,0)
      call GNfini
c
      return
      END
c
c     -----------------------------------------------------------------
c
      SUBROUTINE FastFrac(npsi)
#include "Implic.inc"
#include "tscunits.inc"
#include "params.inc"
#include "FeBins.inc"
#include "PlPr.inc"
      INTEGER npsi, i,j, jwt
      REAL    ExpMax, RsltMin
      REAL    duNorm, duVth2, duFracN, duFracE, duMaxwN, duMaxwE
      REAL    dumFe, dumMx, dumV2, duDelV, exp1
      REAL    wt(2)
      DATA         wt(1)          ,       wt(2)             /
     ^     CONST(0.666666666666,0), CONST(1.333333333333,0) /
      DATA    ExpMax / CONST(100.0,0) /
      REAL ZERO
      DATA ZERO / CONST(0.0,0) /

c     FastFrac: Fast Fraction of N FstFracN and of Energy FstFracE
c     are computed and writtend in Subroutine FastFrac(npsi)
c     du        prefix meaning dummy
c     duNorm    Normalization constant for this flux surface
c               such that f_e(v) = duNorm * exp(-v^2/(2 v_T^2) for
c               Maxwellian
c     duVth2    v_T^2 normalizing the exponent for this flux surface
c     duDelV    The width of the velocity grid at the center
c     duFracN   The fraction of particles in the heated portion of the tail
c     duFracE   The fraction of energy in the heated portion of the tail
c     duMaxwN   "particles" in Maxwellian; (local units not relevant)
c     duMaxwE   "energy" in Maxwellian; (local units not relevant)
c     FeNorm    array dimensioned NPSIDIM containing NeAry/(2 PI)/Vtherm(ip)
c
c     Simpsons Rule is (f1 + 4f2 + f3)h/3 or
c                     (2f1 + 4f2 + 2f3 + 4f4 + 2f5 )h/3 less
c                   - ( f1                      f5 )h/3 which can be ignored
c     because the end points are exponentially small.  The weight (wt) is
c     from the expression  [ 2 + 2( j / 2 ) - j ]  = 1, {j=1,3,5...}
c                                                  = 2, {j=2,4,6...}
c
      duDelV  = abs ( Vpar(IvZero+1) - Vpar(IvZero) )
      RsltMin = exp ( -ExpMax )
      do 20 i = 1, npsi
        duFracN = ZERO
        duFracE = ZERO
        duMaxwN = ZERO
        duMaxwE = ZERO
        duNorm  = FeNorm(i)
        duVth2  = Vtherm(i)*Vtherm(i)
        if ( vtherm(i) .ge. duDelV ) then
          do 10 j = 1, nv
            jwt =  ( 2 + 2 * ( j / 2 ) - j )
            dumFe  =              fe(j,i,iITR) * wt(jwt) * dvsym(j)
            dumV2  = vpar(j)**2 * fe(j,i,iITR) * wt(jwt) * dvsym(j)
            duFracN = duFracN + dumFe
            duFracE = duFracE + dumV2

            exp1 =  vpar(j)*vpar(j)/(2.*duVth2) 
            if(exp1 .lt. ExpMax) then
              exp1 = exp( -exp1 )
            else
              exp1 = RsltMin
            endif
            exp1 = exp1 * duNorm
c           exp1 = exp( -vpar(j)*vpar(j)/(2.*duVth2) )* duNorm
              dumMx  =              exp1 * wt(jwt) * dvsym(j) 
              dumV2  = vpar(j)**2 * exp1 * wt(jwt) * dvsym(j)
              duMaxwN = duMaxwN + dumMx
              duMaxwE = duMaxwE + dumV2
 10       continue

          FstFracN(i) = ( duFracN - duMaxwN ) / duMaxwN
            FstFracE(i) = ( duFracE - duMaxwE ) / duMaxwE
        else
          FstFracN(i) = ZERO
          FstFracE(i) = ZERO
        endif
 20   continue
      if (PrFlg(FSTFRCWR) .ge. TRUE)  then
c       call LSCpause
        write(nLSCcomm,1000)
 1000       format (
     ^'  Psi Index   Fraction Tail Particles  Fraction Tail Energy',/)
         write(nLSCcomm,1001)
     ^                     (  i, FstFracN(i), FstFracE(i)  , i=1,npsi)
 1001       format(t8, i4, t28, 1pe10.3, t50, 1pe10.3)
c       call LSCpause
      endif
      return
      END
c
c     -----------------------------------------------------------------
c
      SUBROUTINE NoPlots
#include "Implic.inc"
#include "params.inc"
#include "PlPr.inc"
      INTEGER i
      do 10 i=1, nPlFlg
        PlFlg(i) = 0
 10   continue
      return
      END
c     ------------------------------------------------------------------
      SUBROUTINE LSCstop ( ErrMsg )
#include "Implic.inc"
#include "tscunits.inc"
      CHARACTER*(*) ErrMsg
      write(nTSCscrn,'('' LSCstop: '',a40 )')
     ^                     ErrMsg
      iError = iError + 1
      return
      END
c     ------------------------------------------------------------------
      SUBROUTINE MkGrfLst ( GrfTitle )
#include "Implic.inc"
#include "tscunits.inc"
      CHARACTER*(*) GrfTitle
c     write(ns30c1,'(a30 )') GrfTitle ! Abandon list of graph titles
      return
      END
c     ------------------------------------------------------------------
      SUBROUTINE LSCwarn ( ErrMsg )
#include "Implic.inc"
#include "tscunits.inc"
      CHARACTER*(*) ErrMsg
      INTEGER nWarning, maxWarn, i, ilen
      SAVE
      DATA    nWarning, maxWarn
     ^            / 0 ,     200 /
      ilen = len(ErrMsg)
      nWarning = nWarning + 1
      if (nWarning .gt. maxWarn ) then
          write(nTSCscrn,'('' LSCquit: '',70a1 )')
     ^                       (ErrMsg(i:i), i=1,ilen)
          call LSCstop ( ' too many warnings issued! ' )
          nWarning = 0
      else if (iRayTrsi .ne. 0) then
          write(nTSCscrn,'('' LSCwarn: '',70a1 )')
     ^                       (ErrMsg(i:i), i=1,ilen)
      else
c     .                                 Do not issue warnings if only re-doing
c     .                                 the J of E calculation:  iRayTrsi=0
          return
      endif
c
c
      return
c     ------------------------------------------------------------------
      ENTRY LSCclear
      nWarning = 0
      iEndRy = 0
      return
      END
c     ------------------------------------------------------------------
      SUBROUTINE LSCendr ( ErrMsg )
c     Trys to end ray tracing asap because an error is encountered
#include "Implic.inc"
#include "params.inc"
#include "RayWrk.inc"
#include "tscunits.inc"
      CHARACTER*(*) ErrMsg
      Lstop = 1
      iEndRy = iEndRy + 1
      call LSCwarn ( ErrMsg )
      return
c     ------------------------------------------------------------------
      ENTRY LSCbigK ( ErrMsg )
      Lstop = 1
      call LSCwarn ( ErrMsg )
      return
      END
c     ------------------------------------------------------------------
      SUBROUTINE LSCtrace ( ErrMsg )
#include "Implic.inc"
#include "tscunits.inc"
      CHARACTER*(*) ErrMsg
      write(nTSCscrn,'('' LSCtrace called on exiting: '',a40 )')
     ^                     ErrMsg
      return
      END
c
c     ------------------------------------------------------------------     
c
      SUBROUTINE GtKcyTim (kcycgot, timegot, namegot)
#include "Implic.inc"
#include "params.inc"
#include "TSCgrap.inc"
      CHARACTER*16 namegot
      INTEGER kcycgot
      REAL    timegot
      kcycgot = kcycle
      timegot = times
      namegot = equhd(2) / / equhd(3)
      return
      END
      BLOCK DATA TSCtimes
#include "Implic.inc"
#include "params.inc"
#include "TSCgrap.inc"
      DATA  iplim, isym, kcycle, npsitm, nspc,       times    /
     ^         -1,   -1,     -1,     -1,   -1, CONST(-1.0,-10)/
      DATA  equhd /10*'        '/
      END
c     -
c     -                                                                |
c     -                                                                |
c     Wr2TSC    ends                        ---------------------------|

